#include<bits/stdc++.h>
using namespace std;
int dp[20000]={999999};
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int s,n;
    cin>>s>>n;
    for(int i=0;i<=s;i++)dp[i]=999999;
    for(int i=0;i<n;i++){
        int t;
        cin>>t;
        dp[t]=1;
    }
    for(int i=2;i<=s;i++){
        if(dp[i]==1)continue;
        for(int j=1;j*2<=i;j++){
            //cout<<dp[i]<<" "<<dp[j]<<"+"<<dp[i-j]<<endl;
            dp[i]=min(dp[i],dp[j]+dp[i-j]);
        }
    }
    cout<<dp[s];
}
